-- Root for Unlimited_Number
-- You may use and modify this file free
-- without deleting this comment group
-- Copyright (c) 1999 Dimitriy Anisimkov
-- e-mail anisimkov@yahoo.com
with Interfaces;
package Unlimited is

--	subtype UInt is Interfaces.Unsigned_<Largest_Integer'Size/2>; 
--	subtype UInt is Interfaces.Unsigned_32; -- GNAT
	subtype UInt is Interfaces.Unsigned_16; -- Most compartible
--	subtype UInt is Interfaces.Unsigned_8;
   type Int is range -UInt'Modulus/2..UInt'Modulus/2-1;
   type LLI is range -UInt'Modulus**2/2..UInt'Modulus**2/2-1;

   type Conversion_Chars is array(Int range <>) of Character;

    function High(l : Lli) return Int;
    function Low(l : Lli) return Int;
    function To_Lli(Low : Int; High : Int) return LLI;

   procedure Set_Low(Dest : in out LLI; Low : Int);
   procedure Set_High(Dest : in out LLI; High : Int);

   function "*"(I1,I2 : Int) return LLI;
   function "*"(Ui : UInt;I : Int) return LLI;
   function "*"(I : Int;Ui : UInt) return LLI;
   function To_LLI(From : Int) return LLI;
   function To_LLI(From : UInt) return LLI;

   pragma Inline(To_LLI,"*",High,Low,Set_High,Set_Low);

end Unlimited;
